package com.citygis.impl;

import cn.hutool.core.util.RandomUtil;
import com.citygis.mapper.TongJiMapper;
import com.citygis.pojo.Tab_log2;
import com.citygis.serivce.TongJiService;
import com.sun.management.OperatingSystemMXBean;
import lombok.Synchronized;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

@Service
public class TongJiServiceImpl implements TongJiService {

    @Resource
    TongJiMapper tongJiMapper;

    @Value("${custom.treadNum}")
    private Integer treadNum;

    @Value("${custom.zhixingnum}")
    private Integer zhixingnum;

    @Value("${custom.stop}")
    private Integer stop;

    @Value("${custom.zuixiao}")
    private Integer zuixiao;

    @Value("${custom.zuida}")
    private Integer zuida;

    @Value("${custom.kaishixianzhi}")
    private Integer kaishixianzhi;

//    @Override
//    @Scheduled(cron = "0 0 * * * ?")
//    public void getErrorCount() {
//        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();
//
//        List<Tab_log2> collect = new ArrayList<>();
//
//        collect = tabLog2s.stream()
//                .filter(tabLog2 -> !tabLog2.getStatus().equals("HTTP/1.1 200"))
//                .collect(Collectors.toList());
//
//        System.out.println("请求失败");
//        collect.forEach(System.out::println);
//    }

//    @Override
//    @Scheduled(cron = "0 0 * * * ?")
//    public void getSucceesCount() {
//        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();
//
//        List<Tab_log2> collect = new ArrayList<>();
//        collect = tabLog2s.stream()
//                .filter(tabLog2 -> tabLog2.getStatus().equals("HTTP/1.1 200"))
//                .collect(Collectors.toList());
//
//        System.out.println("请求成功");
//
//        collect.forEach(System.out::println);
//    }


//    @Override
//    @Scheduled(cron = "0 0 * * * ?")
//    public void getResponseTimeBig() {
//        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();
//
//        List<Tab_log2> collect = new ArrayList<>();
//        collect = tabLog2s.stream()
//                .filter(tabLog2 -> tabLog2.getResponseTime() != null && Integer.parseInt(tabLog2.getResponseTime()) >= 1000)
//                .collect(Collectors.toList());
//
//        System.out.println("响应时间大于1s");
//        collect.forEach(System.out::println);
//    }

    @Override
    @Scheduled(cron = "0 0/3 9-17 * * ?")
    public void getResponseTime() {
        int i = RandomUtil.randomInt(1000, 20000);
        List<Tab_log2> tabLog2s = tongJiMapper.getCount(i);
        tabLog2s.forEach(tabLog2 -> System.out.println("1" + tabLog2));
    }


//    @Override
//    @Scheduled(cron = "0 0/3 * * * ?")
//    public void getCount() {
//        int i = RandomUtil.randomInt(10000, 50000);
//        List<Tab_log2> tabLog2s = tongJiMapper.getCount(i);
//        tabLog2s.forEach(System.out::println);
//    }

    @Override
    @Scheduled(cron = "0 0/5 * * * ?")
    public void getUrl() {
        int i = RandomUtil.randomInt(200);
        if (i >= 100) {
            List<Tab_log2> tabLog2s = tongJiMapper.getOneCount();
            tabLog2s.forEach(tabLog2 -> System.out.println("2" + tabLog2));
        }
    }

    @Override
    @Scheduled(cron = "0 0 * * * ?")
    public void setTabTonaJi() {
        int i = RandomUtil.randomInt(30000);
        List<Tab_log2> twoCount = tongJiMapper.getTwoCount(i);
        twoCount.forEach(tabLog2 -> {
            System.out.println("3");
            tongJiMapper.setTabTongJi(tabLog2);
        });
    }

    @Override
//    @Scheduled(cron = "0 0/15 * * * ?")
    public void meo() {
        // 假设 RandomUtil.randomLong 生成的是介于 3GB 和 5GB 之间的随机数
        for (int i = 0; i < 1000; i++) {
            long targetMemoryInBytes = RandomUtil.randomLong(3000000000L, 5368709120L); // 介于 3GB 和 5GB 之间

            System.out.println("Target memory size: " + targetMemoryInBytes + " bytes");

            // 创建一个临时文件用于映射
            Path path = FileSystems.getDefault().getPath("tempfile.dat");

            // 确保映射大小不超过 Integer.MAX_VALUE (2GB)
            int maxMapSize = Integer.MAX_VALUE; // 2GB
            if (targetMemoryInBytes > maxMapSize) {
                // 大于 2GB 的文件，按块映射
                long remainingBytes = targetMemoryInBytes;
                try (FileChannel fileChannel = FileChannel.open(path, StandardOpenOption.READ, StandardOpenOption.WRITE, StandardOpenOption.CREATE)) {
                    while (remainingBytes > 0) {
                        int mapSize = (int) Math.min(remainingBytes, maxMapSize);
                        // 映射当前块
                        ByteBuffer buffer = fileChannel.map(FileChannel.MapMode.READ_WRITE, targetMemoryInBytes - remainingBytes, mapSize);
                        // 处理该块数据
                        remainingBytes -= mapSize;
                    }
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            } else {
                // 小于等于 2GB 的文件，直接映射
                try (FileChannel fileChannel = FileChannel.open(path, StandardOpenOption.READ, StandardOpenOption.WRITE, StandardOpenOption.CREATE)) {
                    ByteBuffer buffer = fileChannel.map(FileChannel.MapMode.READ_WRITE, 0, targetMemoryInBytes);
                    // 处理映射的内存块
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        }
    }

    @Override
    @Scheduled(cron = "0 0 1 * * ?")
    public void delTabTongJi() {
        tongJiMapper.delTabTongJi();
    }


    @Scheduled(cron = "0/20 * * * * ?")
    public void cputest() {
        int i1 = RandomUtil.randomInt(100);

        int i2 = RandomUtil.randomInt(zuixiao, zuida);

        if (i1 > kaishixianzhi) {

            // 获取系统CPU负载
            ExecutorService executor = Executors.newFixedThreadPool(1);
            OperatingSystemMXBean osBean = ManagementFactory.getPlatformMXBean(OperatingSystemMXBean.class);
            double cpuLoad = osBean.getSystemCpuLoad() * 100;


            // 如果CPU使用率低于指定阈值，则生成CPU占用任务
            if (cpuLoad < stop) {
                // 任务持续时间（单位：毫秒）和空闲时间（单位：毫秒）
                long busyTime = zhixingnum;
                long idleTime = 600;

                // 提交多个任务到线程池
                for (int i = 0; i < i2; i++) {
                    executor.execute(() -> {
                        long startTime = System.currentTimeMillis();
                        while (System.currentTimeMillis() - startTime < busyTime) {
                            // 模拟CPU占用任务
                            double a = Math.PI * Math.E * Math.E * Math.E % 3;
                        }
                        // 任务执行完成后，可以选择休眠一段时间来模拟空闲状态
                        try {
                            Thread.sleep(idleTime);
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                        }
                    });
                }
                executor.shutdown();
                executor.shutdownNow();
//            try {
//                // 等待所有任务完成，最多等待60秒
//                if (!executor.awaitTermination(60, TimeUnit.SECONDS)) {
//                    executor.shutdownNow(); // 强制关闭线程池
//                }
//            } catch (InterruptedException e) {
//                executor.shutdownNow();
//            }
            }
        }
    }
}
